using System;
using Styx;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.Plugins;
using Styx.CommonBot.Frames;
using System.Windows.Media;
using Styx.Common;

namespace seafunk
{
    public class TurboMailer : HBPlugin, IDisposable
    {
        public override string Name { get { return "TurboMailer"; } }
        public override string Author { get { return "seafunk"; } }
        public override Version Version { get { return new Version(2, 1, 0); } }
        public override bool WantButton { get { return false; } }
        public override string ButtonText { get { return Version.ToString(); } }
        public override void OnButtonPress() {}
		
		private int MailVisible
			{get{return Lua.GetReturnVal<int>("local numItems, totalItems = GetInboxNumItems() return numItems", 0);}}
		private int MailInvisible
			{get{return (MailAll - MailVisible);}}
		private int MailAll
			{get{return Lua.GetReturnVal<int>("local numItems, totalItems = GetInboxNumItems() return totalItems", 0);}}
		
		private void Wait(int msecs)
			{DateTime jetzt = DateTime.Now;
			while (DateTime.Now.Subtract(jetzt).TotalMilliseconds < msecs) {}}
			
		private bool once = false;
		
		public override void Pulse() 
		{
			if (MailFrame.Instance.IsVisible )
			{
				if (MailInvisible > 0 && MailVisible < 2 && !once)
				{
					once=true;
                    Logging.Write(Color.FromRgb(173, 255, 47), "[TurboMailer] Reload Now!");
					Lua.DoString("ReloadUI()");
					Wait(2500);
				}
				else if (MailInvisible == 0 || MailVisible > 1)
				{
					once=false;
				}
				
				while (!StyxWoW.IsInWorld)
				{
					Wait(2500);
				}
			}
		}
		
		public override void Dispose() {}
		
        public override void Initialize() {}
    }
}